#!/usr/bin/env python

# Rss Notify
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 3
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, 
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#
# Authors: Isaiah Heyer (freshapplepy@gmail.com)

# Copyright (C) 2009 Isaiah Heyer


import gconf

class Configurator(object):
    """ Class for easier setting and retrieving of
    gconf configurations
    """

    def __init__(self):

        self._client = gconf.client_get_default()

        self._configs = {}

    def register_opt(self, name, key_path, default):

        self._configs[name] = key_path
        
        if not self.get(name):
            self.set(name, default)

    def set(self, name, value):
        
        self._client.set_value(self._configs[name], value)

    def get(self, name):

        return self._client.get(self._configs[name])

