#!/usr/bin/env python

import urllib2
import urlparse
import json
import BeautifulSoup as BS
import traceback

import os


def get_feeds(query):

    rssUrls = []
    
    ### If query is not a valid URL, urllib2
    ### will raise an exception.
    try:
        data1 = urllib2.urlopen(query)

    except ValueError:
        ### Use google feed finding service.
        query = query.replace(" ", "%20")

        data2 = urllib2.urlopen(
            "http://ajax.googleapis.com/ajax/services/"+
            "feed/find?v=1.0&q="+query)

        feeds = json.load(data2)['responseData']['entries']

        urls = []
        for e in feeds:

            rss_url = e['url']
            ### Don't return duplicates.
            if not rss_url in urls:
                urls.append(rss_url)
            

        urls = urls[:5]
        for rss_url in urls[:5]:

            rssUrls.append(rss_url)

        return rssUrls
        
        
    ### First use google feed lookup in case BeautifulSoup
    ### can't parse the page.
    ### This also has the advantage that if the user
    ### enters a straight rss url, it simply echos is back.
    try:
        data2 = urllib2.urlopen(
            "http://ajax.googleapis.com/ajax/services/"+
            "feed/lookup?v=1.0&q="+query)

        rss_url = json.load(data2)['responseData']['url']
        rssUrls.append(rss_url)

    except:
        print traceback.print_exc()

    try:
        
        links = BS.SoupStrainer("link")

        ### Iterator thru every html element in the url
        ### and find rss urls.
        soup = BS.BeautifulSoup(data1, parseOnlyThese=links)
        
        for elem in soup:
            
            if elem.get("type") == "application/rss+xml":

                href = elem.get("href")
                if href:

                    result = urlparse.urlparse(query)
                    result = result.geturl()
                    ### if the url is relative
                    if urlparse.urlparse(href).scheme == "":

                        rss_url = urlparse.urljoin(result, href)

                    ### if the url is absolute
                    else:
                        rss_url = href
                
                
                    if not rss_url in rssUrls:
                        rssUrls.append(rss_url)
    except:
        pass
        #traceback.print_exc()

    return rssUrls
