#!/usr/bin/env python

from distutils.core import setup
import os
import sys


def main():

    SHARE_PATH = os.path.join(os.path.dirname(os.path.abspath(__file__)),
            "share")

    data_files = []

    black_list = ['index.theme', 'index.theme~']

    for path, dirs, files in os.walk(SHARE_PATH):

        data_files.append(tuple((path.replace(SHARE_PATH,"share", 1),
            [os.path.join(path, file) for file in files if file not in
                black_list])))

    setup(name="rss-notify",
        version='0.1',
        description="Rss reader that utilizes notify-osd",
        author="Isaiah Heyer",
        author_email="freshapplepy@gmail.com",
        url="https://launchpad.net/rssn",
        packages=["rss_notify"],
        data_files=data_files,
        scripts=[os.path.join("bin", "rss-notify")]
        )

if __name__ == "__main__":
    main()
